/***************************************************************************
                          keywordinputblock.h  -  description
                             -------------------
    begin                : Fri Feb 14 2003
    copyright            : (C) 2003 by Beheen Trimble
    email                : btrimble@sfwmd.gov
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KEYWORDINPUTBLOCK_H
#define KEYWORDINPUTBLOCK_H

/**
  *@author Beheen Trimble
  */

#include <map>
#include "keywordmgr.h"
#include "keyword.h"

class KeywordInputTerm;


class KeywordInputBlock : public KeywordMgr{
public: 
	KeywordInputBlock();
	virtual ~KeywordInputBlock();

  void setKeyword(Keyword*);
  void setKeywordInputTerm(Keyword*);
  virtual void printKeyword();
  void printKeywordTerm();
  Keyword* getKeywordInputTerm(string);
  virtual Keyword* getKeyword();
  vector<Keyword*> getInputTermKeys();
  vector<KeywordInputTerm*> getInputTerm();
  
private:
  Keyword* keyword;                       // holds the variableName 
  vector<KeywordInputTerm*> keyInputTerm; // holds the term name
};

#endif
